import Payload = Anue.Bridge.Payload;

export default abstract class AbstractClientBridge {
  protected rid = 0;

  static NotInitializedError = {
    rid: -1,
    uri: '/common/error',
    body: {
      message: 'Anue.Bridge.Client not initialized'
    }
  };

  protected mConfig: Anue.Bridge.ClientConfig | null = null;

  constructor(config: Anue.Bridge.ClientConfig) {
    this.mConfig = config;
  }

  protected abstract request(
    request: Anue.Bridge.RequestOptions
  ): Promise<Payload>;
  protected abstract attach(url: string): Promise<boolean>;
}
