/**
 * @doc
 * @anue-base Anue.SharedContext
 * @private
 * `SharedContext`是一個用來處理內部跨模組資料交換的模組，主要用來解決不同的SDK模組在透過
 * webpack封裝後共用變數的存取問題。在開發應用時請__避免__使用這個模組以確保SDK的正常運作。
 *
 * TODO
 *
 */

let scope: any = null;

if (typeof window === 'undefined') {
  // @ts-ignore
  scope = global;
} else {
  scope = window;
}

if (!scope.anue) {
  scope.anue = {};
}

export default {
  set: (key, value) => {
    scope.anue[key] = value;
  },
  get: <T>(key) => {
    return scope.anue[key] as T;
  }
};
