import Email from '@packages/APIs/Email';
import * as Network from '@libraries/Network';
import MockNetworkDriver from '@mocks/mock-network';
import Endpoints from '@constants/Endpoints';

describe('Email API tests', () => {
  Network.setDriver(MockNetworkDriver);

  it('Can send API correctly', async () => {
    MockNetworkDriver.mock(
      opt => opt.url.includes(Endpoints.v1User.registration.email.verify()),
      opt => {
        if (opt.body.checkCode === 'foo') {
          return { statusCode: 200, message: '成功', items: { verify: true } };
        } else {
          return { statusCode: 200, message: '成功', items: { verify: false } };
        }
      }
    );
    const pass = await Email.verifyActivationCode('foo');
    const failed = await Email.verifyActivationCode('bar');

    expect(pass).toBe(true);
    expect(failed).toBe(false);
  });
});
