import AbstractProvider from '@packages/Provider/AbstractProvider.abstract';

export const mockContext = num => {
  return {
    idToken: '$idToken',
    accessToken: '$accessToken',
    tokenType: num
  };
};

export default class MockProvider extends AbstractProvider {
  num = 0;

  constructor(num) {
    super();
    this.num = num;
  }

  loginImpl = async (): Promise<Anue.Provider.NullableResponse> => {
    return await {
      idToken: '$idToken',
      accessToken: '$accessToken',
      tokenType: ''
    };
  };

  logoutImpl = async (): Promise<boolean> => {
    this.mContext = null;
    return await true;
  };

  getName(): string {
    return `mock#${this.num}`;
  }

  refresh(): Promise<Anue.Provider.NullableResponse> {
    throw new Error('Method not implemented.');
  }

  initImpl = jest.fn().mockImplementation(async () => {
    this.mContext = mockContext(this.num);
    this.emitStateChange();
    return await this;
  });

  getContext(): Anue.Provider.NullableResponse {
    return this.mContext;
  }

  getProfile = jest.fn().mockImplementation(
    async (
      args: Anue.Auth.GetProfileArgs
    ): Promise<Anue.Auth.UserProfile | null> => {
      return await {
        avatar: 'mock://avatar',
        email: 'mock@mail.com',
        name: `mocker${this.num}`,
        uid: '$uid'
      };
    }
  );
}
