import * as Storage from '@libraries/Storage';
import * as Network from '@libraries/Network';
import AxiosDriverNetworkDriver from './AxiosDriverNetworkDriver';
import LocalStorageDriver from './LocalStorageDriver';

Storage.setDriver(new LocalStorageDriver());
Network.setDriver(new AxiosDriverNetworkDriver());

Network.addRequestInspector(req => {
  if (req.url.indexOf('/api/v1/user/cognitoOpenIdOrRegister') >= 0) {
    req.url = req.url.replace(
      '/api/v1/user/cognitoOpenIdOrRegister',
      '/driver/api/v1/member/cognitoTokenAndRegister'
    );
  }

  return Promise.resolve(req);
});

export { Storage, Network };
