import * as Storage from '@libraries/Storage';
import * as Network from '@libraries/Network';
import FetchNetworkDriver from './FetchNetworkDriver';
import LocalStorageDriver from './LocalStorageDriver';
import Shared from '@libraries/SharedContext';
import urld from '@utils/urld';

Shared.set('preset-init', () => {
  urld.init();
});

Storage.setDriver(new LocalStorageDriver());
Network.setDriver(new FetchNetworkDriver());

export { Storage, Network };
