export default function(target, prop) {
  const queue: Array<(args) => any> = [];
  target[prop] = (...args) => {
    if (queue.length !== 0) {
      return new Promise(resolve => {
        queue.push(resolve);
      });
    }
    const p = new Promise((resolve, reject) => {
      queue.push(resolve);
      target[prop](...args)
        .then(resolve)
        .catch(reject);
    });
    return p.then(res => {
      while (queue.length > 0) {
        const resolver = queue.shift();
        if (resolver) {
          resolver(res);
        }
      }
      return Promise.resolve(res);
    });
  };
}
