import Shared from '@libraries/SharedContext';

/**
 * @anue-fragment utils-queryThief
 * @doc
 * 將URL query取出並塞入到全域變數中使用，然後移除 URL 中的 query
 * 儲存位置為 window.anue.queryThief
 * @param key 要取出的query value 所對應的 key，並須為字串
 */
const queryThief = {
  get: <T = any>(key): T => Shared.get<T>('queryThief')[key]
};

if (typeof location !== 'undefined') {
  const pat = /\A?\w+=[^&]+&*/g;
  const query = location.search;
  const matches = query.match(pat);
  const data = {};

  if (matches) {
    console.log('[queryThief] get queryString = %o', matches);
    matches.forEach(m => {
      const singleQuery = m.replace(/[?#&]/, '');
      const pairs = singleQuery.split('=');
      data[pairs[0]] = decodeURIComponent(pairs[1]);
    });
    Shared.set('queryThief', data);
  } else {
    Shared.set('queryThief', {});
  }
  console.log('queryThief consumed query', query);
  history.pushState(
    null,
    document.title,
    location.protocol +
      '//' +
      location.hostname +
      location.pathname +
      location.hash
  );
}

export default queryThief;
