import Shared from '@libraries/SharedContext';

const urld = {
  init: () => {
    if (typeof location !== 'undefined') {
      const pat = /[^\=#\?\&]+\=[^&#]+/g;
      const matchesHash = location.hash.match(pat) || [];
      const matchesQuery = location.search.match(pat) || [];
      const data = {};
      const matches = matchesHash.concat(matchesQuery);

      if (matches) {
        console.log('[urld] matches = %o', matches);
        matches.forEach(m => {
          const pairs = m.split('=');
          data[pairs[0].replace('anue_', '')] = decodeURIComponent(pairs[1]);
          console.log(
            'urld set %s => %s',
            pairs[0].replace('anue_', ''),
            decodeURIComponent(pairs[1])
          );
        });
        Shared.set('urld', data);
      } else {
        Shared.set('urld', {});
      }
      console.log(
        '[urld] consumed hashes and queries as object in SharedContext %o',
        data
      );
      let url =
        location.protocol +
        '//' +
        location.hostname +
        ':' +
        location.port +
        location.pathname +
        location.hash.replace(pat, '');
      url = url.replace(/&+/g, '');
      history.pushState(null, document.title, url);
    }
  },
  get: <T = any>(key): T => (Shared.get<T>('urld') || {})[key]
};

export default urld;
