const path = require('path')

module.exports = {
  mode: 'development',
  entry: path.resolve(__dirname, './sandbox/source.js'),
  devtool: 'source-map',
  module: {
    rules: [{
      test: /\.js$/,
      use: {
        loader: 'babel-loader',
        options: {
          presets: ['@babel/preset-env', '@babel/preset-react'],
          plugins: ["@babel/plugin-proposal-class-properties"]
        }
      },
      exclude: /node_modules/
    }, {
      test: /\.scss$/,
      use: [
        "isomorphic-style-loader", // creates style nodes from JS strings
        {
          loader: 'css-loader',
          options: {
            importLoaders: 1
          }
        },
        "postcss-loader" // compiles Sass to CSS, using Node Sass by default
      ]
    }]
  },
  resolve: {
    extensions: ['.js'],
    alias: {
      'anue-fe-sdk': path.resolve(__dirname, './build')
    }
  },
  output: {
    filename: "sandbox.bundle.js",
    path: path.resolve(__dirname, './sandbox')
  }
}
